//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

int main(int argc, char* argv[])
{
  vector<int> coll1;  //  
  vector<int> coll2;  //  
  // :     

  vector<int>::iterator pos = coll1.begin(); 
  reverse (++pos,coll1.end());
  //      1  9  coll2 
  for (int i=1; i<=9; ++i) {
    coll2.push_back(i);
  }


  PRINT_ELEMENTS(coll2," coll2:\n");

  // :   
  copy (coll2.begin(), coll2.end(),  // 
        coll1.begin());     //

  PRINT_ELEMENTS(coll1," coll1:\n");

  // :
  // -  
  // -  begin()  end()
  copy (coll1.begin(), coll2.end(),     // 
        coll1.end());

  PRINT_ELEMENTS(coll1," coll1:\n");

  cout << endl;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
